
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, StdCtrls, ExtCtrls, LPTIO, MPlayer, Grids, ValEdit,
  Menus, ExtDlgs;

type
  TForm1 = class(TForm)
    GroupBox2: TGroupBox;
    Button1: TButton;
    Button2: TButton;
    cs: TClientSocket;
    Edit1: TEdit;
    Label16: TLabel;
    Edit2: TEdit;
    Label18: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    Label10: TLabel;
    Label14: TLabel;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    panLPT2: TPanel;
    panLPT3: TPanel;
    panLPT4: TPanel;
    panLPT5: TPanel;
    panLPT6: TPanel;
    panLPT7: TPanel;
    panLPT8: TPanel;
    panLPT9: TPanel;
    panLPT10: TPanel;
    panLPT11: TPanel;
    panLPT12: TPanel;
    panLPT13: TPanel;
    panLPT15: TPanel;
    Label4: TLabel;
    Label5: TLabel;
    ComboBox1: TComboBox;
    Label7: TLabel;
    Timer1: TTimer;
    MediaPlayer1: TMediaPlayer;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    GroupBox3: TGroupBox;
    ListBox1: TListBox;
    Button6: TButton;
    OpenDialog1: TOpenDialog;
    Button7: TButton;
    Button8: TButton;
    GroupBox4: TGroupBox;
    Image1: TImage;
    Button9: TButton;
    Button10: TButton;
    GroupBox5: TGroupBox;
    Button11: TButton;
    Button12: TButton;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    N11: TMenuItem;
    N12: TMenuItem;
    Button13: TButton;
    N13: TMenuItem;
    N14: TMenuItem;
    Panel2: TPanel;
    Image2: TImage;
    OpenDialog2: TOpenPictureDialog;
    ValueListEditor1: TValueListEditor;
    procedure csConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure csConnecting(Sender: TObject; Socket: TCustomWinSocket);
    procedure csDisconnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure csError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure csRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Change(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure panLPT2Click(Sender: TObject);
    procedure panLPT3Click(Sender: TObject);
    procedure panLPT4Click(Sender: TObject);
    procedure panLPT5Click(Sender: TObject);
    procedure panLPT6Click(Sender: TObject);
    procedure panLPT7Click(Sender: TObject);
    procedure panLPT8Click(Sender: TObject);
    procedure panLPT9Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button13Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
  private
    Lpt: TLptPortConnection;
    procedure GetLPTInput;
  public
  end;

var
  Form1: TForm1;

implementation

uses Unit2,Unit3;

var
  currentLPT: byte;
  LPTprev: array[0..2] of longint;
  error_time, busy_time: longint;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Edit1.Color := clWindow;
  Edit2.Color := clWindow;
  Panel1.Color := clRed;
  Button1Click(Sender);
  Button1.Enabled := False;
  Lpt:=TLptPortConnection.Create;
  if not Lpt.Ready then begin
    Application.MessageBox(PChar('    Lpt,  = ' + IntToStr(GetLastError())),'ERROR',MB_OK);
    ComboBox1.Enabled:=false;
    currentLPT:= 0;
  end else begin
    ComboBox1.Items.Clear;
    ComboBox1.Text := '';
    if Lpt.IsPortPresent(LPT1) then ComboBox1.Items.Add('LPT1 ( $3BC)');
    if Lpt.IsPortPresent(LPT2) then ComboBox1.Items.Add('LPT2 ( $378)');
    if Lpt.IsPortPresent(LPT3) then ComboBox1.Items.Add('LPT3 ( $278)');

    if 0<>ComboBox1.Items.Count then begin
     ComboBox1.ItemIndex := 0;
     if (ComboBox1.Items[0]='LPT1 ( $3BC)') then
       currentLPT:= LPT1;
     if (ComboBox1.Items[0]='LPT2 ( $378)') then
       currentLPT:= LPT2;
     if (ComboBox1.Items[0]='LPT3 ( $278)') then
       currentLPT:= LPT3;
    end;
  end;
end;

procedure TForm1.GetLPTInput;
var x:longint;
    i:integer;
    aLPT:array[0..2]of integer;
begin
 aLPT[0]:=LPT1; aLPT[1]:=LPT2; aLPT[2]:=LPT3;
 for i:=0 to 2 do
   if Lpt.IsPortPresent(aLPT[i]) then begin
     x:=Lpt.ReadPort(aLPT[i],1);
     if x<>LPTprev[i] then begin
      ;;;; {    LPT}
     end;
     LPTprev[i]:=x;
   end;

 x:= Lpt.ReadPort(currentLPT,1);

 {10}
 if (ACK  = (ACK  and x)) then begin
   if panLPT10.Color<>clLime then
     panLPT10.Color:=clLime;
 end else begin
   if panLPT10.Color<>clBtnFace then
     panLPT10.Color:=clBtnFace;
 end;

 {11}
 if (BUSY = (BUSY and x)) then begin
   if panLPT11.Color<>clLime then
     panLPT11.Color:=clLime;
 end else begin
   if panLPT11.Color<>clBtnFace then
     panLPT11.Color:=clBtnFace;
 end;

 {12}
 if (PAPEREND  = (PAPEREND and x)) then begin
   if panLPT12.Color<>clLime then
     panLPT12.Color:=clLime;
 end else begin
   if panLPT12.Color<>clBtnFace then
     panLPT12.Color:=clBtnFace;
 end;

 {13}
 if (SELECT = (SELECT and x)) then begin
   if panLPT13.Color<>clLime then
     panLPT13.Color:=clLime;
 end else begin
   if panLPT13.Color<>clBtnFace then
     panLPT13.Color:=clBtnFace;
 end;

 {15}
 if (ERROR  = (ERROR and x)) then begin
   if panLPT15.Color<>clLime then
     panLPT15.Color:=clLime;
 end else begin
   if panLPT15.Color<>clBtnFace then
     panLPT15.Color:=clBtnFace;
 end;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if (Edit1.Text = '') or (Edit2.Text = '') then
  begin
    Memo1.Lines.Add(' :  IP-  !');
  end
  else
  begin
    cs.Address := Edit1.Text;
    cs.Port := StrToInt(Edit2.Text);
    cs.Active := True;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  cs.Active := False;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  if (OpenDialog1.Execute) then
    ListBox1.Items[ListBox1.ItemIndex]:=inttostr(ListBox1.ItemIndex)+' '+OpenDialog1.FileName;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  if (ComboBox1.Items[ComboBox1.ItemIndex]='LPT1 ( $3BC)') then
    currentLPT:= LPT1;
  if (ComboBox1.Items[ComboBox1.ItemIndex]='LPT2 ( $378)') then
    currentLPT:= LPT2;
  if (ComboBox1.Items[ComboBox1.ItemIndex]='LPT3 ( $278)') then
    currentLPT:= LPT3;
end;

procedure TForm1.panLPT2Click(Sender: TObject);
begin
  if currentLPT=0 then exit;
  Lpt.WritePort(currentLPT,0,(01 xor Lpt.ReadPort(currentLPT,0))) ;
  if TPanel(Sender).Color=clLime then
    TPanel(Sender).Color:=clBtnFace
  else
    TPanel(Sender).Color:=clLime;
end;

procedure TForm1.panLPT3Click(Sender: TObject);
begin
  if currentLPT=0 then exit;
  Lpt.WritePort(currentLPT,0,(02 xor Lpt.ReadPort(currentLPT,0))) ;
  if TPanel(Sender).Color=clLime then
    TPanel(Sender).Color:=clBtnFace
  else
    TPanel(Sender).Color:=clLime;
end;

procedure TForm1.panLPT4Click(Sender: TObject);
begin
  if currentLPT=0 then exit;
  Lpt.WritePort(currentLPT,0,(03 xor Lpt.ReadPort(currentLPT,0))) ;
  if TPanel(Sender).Color=clLime then
    TPanel(Sender).Color:=clBtnFace
  else
    TPanel(Sender).Color:=clLime;
end;

procedure TForm1.panLPT5Click(Sender: TObject);
begin
  if currentLPT=0 then exit;
  Lpt.WritePort(currentLPT,0,(04 xor Lpt.ReadPort(currentLPT,0))) ;
  if TPanel(Sender).Color=clLime then
    TPanel(Sender).Color:=clBtnFace
  else
    TPanel(Sender).Color:=clLime;
end;

procedure TForm1.panLPT6Click(Sender: TObject);
begin
  if currentLPT=0 then exit;
  Lpt.WritePort(currentLPT,0,(05 xor Lpt.ReadPort(currentLPT,0))) ;
  if TPanel(Sender).Color=clLime then
    TPanel(Sender).Color:=clBtnFace
  else
    TPanel(Sender).Color:=clLime;
end;

procedure TForm1.panLPT7Click(Sender: TObject);
begin
  if currentLPT=0 then exit;
  Lpt.WritePort(currentLPT,0,(06 xor Lpt.ReadPort(currentLPT,0))) ;
  if TPanel(Sender).Color=clLime then
    TPanel(Sender).Color:=clBtnFace
  else
    TPanel(Sender).Color:=clLime;
end;

procedure TForm1.panLPT8Click(Sender: TObject);
begin
  if currentLPT=0 then exit;
  Lpt.WritePort(currentLPT,0,(07 xor Lpt.ReadPort(currentLPT,0))) ;
  if TPanel(Sender).Color=clLime then
    TPanel(Sender).Color:=clBtnFace
  else
    TPanel(Sender).Color:=clLime;
end;

procedure TForm1.panLPT9Click(Sender: TObject);
begin
  if currentLPT=0 then exit;
  Lpt.WritePort(currentLPT,0,(08 xor Lpt.ReadPort(currentLPT,0))) ;
  if TPanel(Sender).Color=clLime then
    TPanel(Sender).Color:=clBtnFace
  else
    TPanel(Sender).Color:=clLime;
end;

procedure TForm1.Button3Click(Sender: TObject);
var s:string;
begin
  s:=copy(ListBox1.Items[ListBox1.ItemIndex],3,length(ListBox1.Items[ListBox1.ItemIndex]));
  if (s<>'( )') then begin
    MediaPlayer1.FileName:=s;
    MediaPlayer1.Open;
    MediaPlayer1.Play;
  end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  if (MediaPlayer1.Mode=mpPlaying) then
    MediaPlayer1.Stop;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  if ListBox1.ItemIndex=-1 then exit;
  ListBox1.Items[ListBox1.ItemIndex]:=inttostr(ListBox1.ItemIndex)+' ( )';
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  Form2.ShowModal;
end;

procedure TForm1.Button13Click(Sender: TObject);
begin
  {...}
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  if OpenDialog2.Execute then begin
    Image1.Picture.LoadFromFile(OpenDialog2.FileName);
  end;
end;

procedure TForm1.Button11Click(Sender: TObject);
begin
  {...}
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  cs.Active := False;
  Lpt.Destroy;
  Application.Terminate;
end;

procedure TForm1.csConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  Memo1.Lines.Add('   .');
  Button1.Enabled := False;
  Button2.Enabled := True;
  Edit1.ReadOnly := True;
  Edit1.Color := clBtnFace;
  Edit2.ReadOnly := True;
  Edit2.Color := clBtnFace;
  Panel1.Color := clLime;
end;

procedure TForm1.csConnecting(Sender: TObject; Socket: TCustomWinSocket);
begin
  Memo1.Lines.Add('   '+cs.Address+':'+inttostr(cs.Port)+'...');
  Button1.Enabled := False;
  Button2.Enabled := False;
  Edit1.ReadOnly := True;
  Edit1.Color := clBtnFace;
  Edit2.ReadOnly := True;
  Edit2.Color := clBtnFace;
  Panel1.Color := clYellow;
end;

procedure TForm1.csDisconnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  Memo1.Lines.Add(' .');
  Button1.Enabled := True;
  Button2.Enabled := False;
  Edit1.ReadOnly := False;
  Edit1.Color := clWindow;
  Edit2.ReadOnly := False;
  Edit2.Color := clWindow;
  Panel1.Color := clRed;
end;

procedure TForm1.csError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  Memo1.Lines.Add(' : ' + IntToStr(ErrorCode));
  Button1.Enabled := True;
  Button2.Enabled := False;
  Edit1.ReadOnly := False;
  Edit1.Color := clWindow;
  Edit2.ReadOnly := False;
  Edit2.Color := clWindow;
  Panel1.Color := clRed;
end;

procedure TForm1.csRead(Sender: TObject; Socket: TCustomWinSocket);
var
  s, t : string;
  i, x : integer;
  params : array[1..4] of string;
  partend: integer;
begin
  s := cs.Socket.ReceiveText;
  delete(s,length(s),1);
  Memo1.Lines.Add(' ' + s);
  t := s;
  for i := 1 to 3 do
  begin
    partend := Pos(' ', t);
    params[i] := Copy(t, 1, partend - 1);
    Delete(t, 1, partend);
  end;
  params[4] := t;
  Delete(params[4], length(params[4]), 1);
  if (Form2.Active) then begin
    with Form2.ValueListEditor1 do
      Values[Keys[Row]]:= params[3];
    Label2.Caption := '    ';
    exit;
  end;

  if (params[2]<>'00') then exit;

  Label14.Caption := '['+params[3]+']';
  
  for i:=0 to DCfunc_num-1 do
    if params[3]=DCfunc_values[i] then begin
      Label14.Caption := DCfunc_names[i];

      if (i=DCfunc_cancel) then begin
        {Stop Recording}
        {Stop Moving}
        {Stop Playing music}
        if (MediaPlayer1.Mode=mpPlaying) then
          MediaPlayer1.Stop;
        {Stop operating LPTs}
        if Lpt.IsPortPresent(LPT1) then Lpt.WritePort(LPT1,0,0);
        if Lpt.IsPortPresent(LPT2) then Lpt.WritePort(LPT2,0,0);
        if Lpt.IsPortPresent(LPT3) then Lpt.WritePort(LPT3,0,0);
        STATE:=STATE_nothing;
      end;
      case STATE of
        STATE_busy:begin
          busy_time:=0;
        end;
        STATE_nothing:
          case i of
            DCfunc_play:STATE:=STATE_play1;
            DCfunc_go:STATE:=STATE_go1;
            DCfunc_wait:STATE:=STATE_wait1;
            DCfunc_record:STATE:=STATE_record1;
            DCfunc_comp_cmd:STATE:=STATE_comp_cmd1;
          end;
        STATE_go1,
        STATE_play1,
        STATE_wait1,
        STATE_record1:begin
          if (i<DCfunc_0) or (i>DCfunc_9) then begin
            STATE:=STATE_error;
            error_time:=0;
          end else begin
            x:= i-DCfunc_0;
            case STATE of
              STATE_go1: {    };
              STATE_play1: begin
                s:=copy(ListBox1.Items[x],3,length(ListBox1.Items[x]));
                if (s<>'( )') then begin
                  MediaPlayer1.FileName:=s;
                  MediaPlayer1.Open;
                  MediaPlayer1.Play;
                end else begin
                  STATE:=STATE_error;
                  error_time:=0;
                  break;
                end;
              end;
              STATE_wait1: { };
              STATE_record1: {     };
            end;
            STATE:=STATE_busy;
          end;
        end;
        STATE_comp_cmd1:
          if i=DCfunc_comp_cmd then begin
            STATE:=STATE_nothing;
          end;
      end;
      Label2.Caption := STATE_desc[STATE];
      break;
    end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  GetLPTInput;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  Image2.Picture.Bitmap:=Image1.Picture.Bitmap;
  Image2.Height:=Image2.Picture.Bitmap.Height+2;
  Image2.Width:=Image2.Picture.Bitmap.Width+2;
  Panel2.Visible:=not Panel2.Visible;
end;

procedure TForm1.Image2Click(Sender: TObject);
begin
  Panel2.Visible:=not Panel2.Visible;
end;

end.
